sleep 1
#!/system/bin/sh
MODDIR=${0%/*}
setprop debug.sensors.diag_buffer_log "true"
setprop debug.sf.hw "0"
setprop debug.egl.hw "0"
setprop debug.sf.latch_unsignaled "1"
setprop debug.sf.enable_gl_backpressure "1"
setprop debug.sf.high_fps_late_app_phase_offset_ns "1000000"
setprop debug.mdpcomp.logs "0"
setprop debug.sf.enable_advanced_sf_phase_offset "1"
setprop debug.sf.high_fps_late_sf_phase_offset_ns "-4000000"
setprop debug.sf.high_fps_early_phase_offset_ns "-4000000"
setprop debug.sf.high_fps_early_gl_phase_offset_ns "-4000000"
setprop debug.stagefright.omx_default_rank "0"
setprop debug.stagefright.ccodec "1"
setprop debug.media.vpp.enable "false"
setprop debug.media.video.frc "false"
setprop debug.media.video.vpp "false"
setprop debug.media.video.style "false"
cmd looper_stats disable
cmd power set-adaptive-power-saver-enabled false
cmd power set-fixed-performance-mode-enabled true
renice -n -20 -p $(pgrep -x surfaceflinger)
dumpsys deviceidle whitelist +com.google.android.gms 
cmd appops set com.google.android.gms RUN_ANY_IN_BACKGROUND ignore
cmd appops set com.google.android.gms START_FOREGROUND ignore
cmd appops set com.google.android.gms INSTANT_APP_START_FOREGROUND ignore
cmd appops set com.google.android.ims RUN_IN_BACKGROUND ignore
cmd appops set com.google.android.ims RUN_ANY_IN_BACKGROUND ignore
cmd appops set com.google.android.ims START_FOREGROUND ignore
cmd appops set com.google.android.ims INSTANT_APP_START_FOREGROUND ignore
swapoff /dev/block/zram0
cmd power set-mode 0
cmd thermalservice override-status 0
dumpsys deviceidle enable
dumpsys deviceidle force-idle
dumpsys deviceidle step deep
dumpsys deviceidle whitelist +com.dts.freefiremax
dumpsys deviceidle whitelist +com.tencent.ig
dumpsys deviceidle whitelist +com.mobile.legends
dumpsys deviceidle whitelist +com.android.systemui
dumpsys deviceidle whitelist +com.mojang.minecraftpe
dumpsys deviceidle whitelist +com.netease.newspike
cmd package compile -m everything-profile -f com.dts.freefiremax
cmd package compile -m everything-profile -f com.tencent.ig
cmd package compile -m everything-profile -f com.mojang.minecraftpe
cmd package compile -m everything-profile -f com.mobile.legends
cmd package compile -m everything-profile -f com.roblox.client
cmd package compile -m everything-profile -f com.netease.newspike
cmd package compile -r first-boot -f com.netease.newspike
cmd package compile -r first-boot -f com.mojang.minecraftpe
cmd package compile -r first-boot -f com.dts.freefiremax
cmd package compile -r first-boot -f com.mobile.legends
cmd package compile -r first-boot -f com.roblox.client
cmd package compile -r first-boot -f com.tencent.ig
cmd package compile -m speed-profile -f com.ea.gp.fifamobile
cmd package compile -m speed-profile -f com.proximabeta.mf.uamo
(
for a in $(dumpsys deviceidle whitelist | cut -f 2 -d ,);do
dumpsys deviceidle whitelist -$a
done
) > /dev/null 2>&1 &
(
for b in $(cmd package list packages | cut -f 2 -d :);do
am set-standby-bucket $b restricted
cmd appops set $b RUN_ANY_IN_BACKGROUND ignore
cmd appops set $b RUN_IN_BACKGROUND ignore
done
) > /dev/null 2>&1 &
(
for c in android $(cmd package list packages | grep sys | cut -f 2 -d :) com.dts.freefiremax com.mobile.legends ;do
am set-standby-bucket $c active
cmd appops set $c RUN_ANY_IN_BACKGROUND allow
cmd appops set $c RUN_IN_BACKGROUND allow
dumpsys deviceidle whitelist +$c
done
) > /dev/null 2>&1 &
#entropy buat performance
entropy=$(cat /proc/sys/kernel/random/poolsize)

echo "1024" > /proc/sys/kernel/random/read_wakeup_threshold
echo "512" >/proc/sys/kernel/random/write_wakeup_threshold
echo "$entropy" > /proc/sys/kernel/random/write_wakeup_threshold
echo "$entropy" > /proc/sys/kernel/random/entropy_avail
#low memory killer
echo "2560,5120,11520,25600,35840,38400" > /sys/module/lowmemorykiller/parameters/minfree
#kernel panik
echo "0" > /proc/sys/kernel/panic_on_oops
echo "0" > /proc/sys/kernel/panic_on_rcu_stall
echo "0" > /proc/sys/kernel/panic_on_warn
echo "0" > /sys/module/kernel/parameters/panic
echo "0" > /sys/module/kernel/parameters/panic_on_warn
echo "0" > /sys/module/kernel/parameters/panic_on_oops
echo "0" > /sys/vm/panic_on_oom
#kernel twiks
echo "NO_GENTLE_FAIR_SLEEPERS:1" > /sys/kernel/debug/sched_features
echo "START_DEBIT:1" > /sys/kernel/debug/sched_features
echo "NEXT_BUDDY:1" > /sys/kernel/debug/sched_features
echo "LAST_BUDDY:1" > /sys/kernel/debug/sched_features
echo "STRICT_SKIP_BUDDY:1" > /sys/kernel/debug/sched_features
echo "CACHE_HOT_BUDDY:1" > /sys/kernel/debug/sched_features
echo "WAKEUP_PREEMPTION:1" > /sys/kernel/debug/sched_features
echo "NO_HRTICK:1" > /sys/kernel/debug/sched_features
echo "NO_DOUBLE_TICK:1" > /sys/kernel/debug/sched_features
echo "LB_BIAS:1" > /sys/kernel/debug/sched_features
echo "NONTASK_CAPACITY:1" > /sys/kernel/debug/sched_features
echo "NO_TTWU_QUEUE:1" > /sys/kernel/debug/sched_features
echo "NO_SIS_AVG_CPU:1" > /sys/kernel/debug/sched_features
echo "RT_PUSH_IPI:1" > /sys/kernel/debug/sched_features
echo "NO_FORCE_SD_OVERLAP:1" > /sys/kernel/debug/sched_features
echo "NO_RT_RUNTIME_SHARE:1" > /sys/kernel/debug/sched_features
echo "NO_LB_MIN:1" > /sys/kernel/debug/sched_features
echo "ATTACH_AGE_LOAD:1" > /sys/kernel/debug/sched_features
echo "ENERGY_AWARE:1" > /sys/kernel/debug/sched_features
echo "NO_MIN_CAPACITY_CAPPING:1" > /sys/kernel/debug/sched_features
echo "NO_FBT_STRICT_ORDER:1" > /sys/kernel/debug/sched_features
echo "EAS_USE_NEED_IDLE:1" > /sys/kernel/debug/sched_features
#somthing
echo "1000" > /dev/blkio/blkio.weight
echo "200" > /dev/blkio/background/blkio.weight
echo "2000" > /dev/blkio/blkio.group_idle
echo "0" > /dev/blkio/background/blkio.group_idle
#powerhalllllllll
echo -e "com.mobile.legends\com.netmarble.sololv\ncom.tencent.ig\ncom.miHoYo.GenshinImpact\ncom.tencent.tmgp.pubgmhd\ncom.dts.freefireth\ncom.dts.freefiremax\njp.konami.pesam\ncom.pubg.newstate\ncom.garena.game.codm\ncom.pubg.imobile\ncom.ea.gp.apexlegendsmobilefps\ncom.riotgames.league.wildrift\ncom.tencent.tmgp.sgame\ncom.tencent.iglite\ncom.vng.pubgmobile\ncom.miHoYo.bh3oversea\ncom.pubg.krmobile\ncom.rekoo.pubgm\ncom.activision.callofduty.shooter\n" > /data/vendor/powerhal/smart
#matiin log gpu
echo "0" > /sys/kernel/debug/kgsl/kgsl-3d0/log_level_cmd
echo "0" > /sys/kernel/debug/kgsl/kgsl-3d0/log_level_ctxt
echo "0" > /sys/kernel/debug/kgsl/kgsl-3d0/log_level_drv
echo "0" > /sys/kernel/debug/kgsl/kgsl-3d0/log_level_mem
echo "0" > lsys/kernel/debug/kgsl/kgsl-3d0/log_level_pwr
#trim
fstrim -v /system
fstrim -v /vendor
fstrim -v /data
fstrim -v /cache
fstrim -v /system
fstrim -v /vendor
fstrim -v /metadata
fstrim -v /odm
fstrim -v /system_ext
fstrim -v /product
fstrim -v /data
fstrim -v /cache
#Kernel Tweaks
echo "55" > /proc/sys/kernel/perf_cpu_time_max_percent
echo "24000" > /proc/sys/kernel/perf_event_max_sample_rate
echo "570" > /proc/sys/kernel/perf_event_mlock_kb
echo "0" > /proc/sys/kernel/sched_boost
echo "95" > /proc/sys/kernel/sched_downmigrate
echo "160" > /proc/sys/kernel/sched_group_upmigrate
#Ram Tweak
# The stat_interval one reduces jitter 
echo "40" > /proc/sys/kernel/vfs_cache_pressure
echo "20" > /proc/sys/kernel/stat_interval
echo "32" > /proc/sys/kernel/watermark_scale_factor
echo "0" > /proc/sys/kernel/compaction_proactiveness
echo "0" > /proc/sys/kernel/page-cluster

#disable thermal settings
if [ -d /sys/module/msm_thermal ]; then
 lock_val "0" /sys/module/msm_thermal/core_control/enabled
 lock_val "N" /sys/module/msm_thermal/parameters/enabled
 lock_val "0" /sys/module/msm_thermal/vdd_restriction/enabled
fi

#improve overall performance
echo "125" > /proc/sys/vm/dirty_writeback_centisecs
echo "100" > /proc/sys/vm/extfrag_threshold
echo "74680" > /proc/sys/vm/extra_free_kbytes
echo "100" > /proc/sys/kernel/perf_cpu_time_max_percent
echo "9" > /proc/sys/kernel/perf_event_max_contexts_per_stack
echo "0" > /proc/sys/kernel/perf_event_max_stack
echo "100000" > /proc/sys/kernel/sched_latency_ns
echo "0" > /proc/sys/kernel/sched_nr_migrate
echo "0" > /proc/sys/kernel/sched_rt_runtime_us
echo "0" > /proc/sys/kernel/seccomp/actions_logged
echo "0" > /proc/sys/kernel/sched_migration_cost_ns
echo "0" > /proc/sys/kernel/sched_rr_timeslice_ms
echo "50" > /proc/sys/kernel/sched_rt_period_us
echo "1" > /proc/sys/kernel/sched_time_avg_ms
echo "100 100" > /proc/sys/kernel/sched_upmigrate
echo "100 100" > /proc/sys/kernel/sched_downmigrate
echo "0" > /proc/sys/kernel/sched_walt_rotate_big_tasks

#Dev Stune Boost
# Fast Sensivity in Game
write "/dev/stune/background/schedtune.boost" "20"
write "/dev/stune/background/schedtune.prefer_idle" "0"
write "/dev/stune/background/schedtune.colocate" "0"
write "/dev/stune/background/schedtune.sched_boost_enabled" "1"

write "/dev/stune/foreground/schedtune.boost" "20"
write "/dev/stune/foreground/schedtune.prefer_idle" "0"
write "/dev/stune/foreground/schedtune.colocate" "0"
write "/dev/stune/foreground/schedtune.sched_boost_enabled" "1"

write "/dev/stune/rt/schedtune.boost" "20"
write "/dev/stune/rt/schedtune.prefer_idle" "0"
write "/dev/stune/rt/schedtune.colocate" "0"
write "/dev/stune/rt/schedtune.sched_boost_enabled" "0"

write "/dev/stune/top-app/schedtune.boost" "20"
write "/dev/stune/top-app/schedtune.prefer_idle" "0"
write "/dev/stune/top-app/schedtune.colocate" "0"
write "/dev/stune/top-app/schedtune.sched_boost_enabled" "0"

write "/dev/stune/schedtune.boost" "20"
write "/dev/stune/schedtune.prefer_idle" "0"
write "/dev/stune/schedtune.colocate" "0"
write "/dev/stune/schedtune.sched_boost_enabled" "0"

done